require "active_support/concern"
require "dionysus/redcarpet"

module Dionysus
  module Redcarpet
    module Plaintext
      extend ActiveSupport::Concern

      included do
        if method_defined?(:preprocess)
          alias_method_chain :preprocess, :plaintext
        else
          alias_method :preprocess, :preprocess_with_plaintext
        end
      end

      def preprocess_with_plaintext(full_document)
        if full_document =~ FILE_DIRECTIVE_REGEXP
          if $1 == "md" and $2 == "plaintext"
            full_document = "```\n#{full_document.gsub(FILE_DIRECTIVE_REGEXP, "")}\n```"
          end
        end

        if respond_to? :preprocess_without_plaintext
          preprocess_without_plaintext(full_document)
        else
          full_document
        end
      end
    end
  end
end

Redcarpet::Render::HTML.send(:include, Dionysus::Redcarpet::Plaintext)
